# Name:        RateMap v1.2
#
# Author:      JoeyT2007
#
# Description: Allows players to rate their favourite maps.
#
# Commands:    !ratemap - Brings up the rating menu, or the error message if you have already rated.
#              !rate - Brings up the rating menu, or the error message if you have already rated.
#              !rm - Brings up the rating menu, or the error message if you have already rated.
#              !rating - Tells the user what the current map is rated.
#              !rating [map] - Tells the user what the chosen map is rated.
#              !list - Shows the users all maps in a list and their ratings.
#              !rmhelp - Brings up the command help menu.
#
# Credits:     Creator         JoeyT2007
#
#              Help            NATO_Hunter
#                              R`SiN
#                              Errant

import es
from es import server_var
import popuplib
import keyvalues
import os
import playerlib
import string
import threading
import MySQLdb

###CONFIG###
rm_onteam = es.ServerVar("rm_onteam", "1", "Make the ratemap menu popup when choosing a team?")
############

###MYSQL###
# Save map rating's to a mysql database?
rm_usemysql = 0

# MySQL Host
rm_host = "website.com"

# MySQL Database
rm_database = "database"

# MySQL Database Username
rm_username = "username"

# MySQL Database Password
rm_password = "password"
###########

ratemap_ver = es.ServerVar("ratemap_ver", "1.2", "Version of RateMap that you are using.")
ratemap_ver.makepublic()

class DoSql(threading.Thread):
    def run(self):
        if rm_usemysql == 1:
            db = MySQLdb.connect(rm_host, rm_username, rm_password, rm_database)
            rm_map = es.ServerVar("eventscripts_currentmap")
            rm_path = es.getAddonPath('ratemap') + "/data/" + rm_map + '.dat'
            if os.path.exists(rm_path):
                mapkey = keyvalues.KeyValues(name=str(rm_map))
                mapkey.load(rm_path)
                if 'fivestars' in mapkey:
                    rm_fivestars = mapkey['fivestars']['count']
                else:
                    rm_fivestars = 0
                if 'fourstars' in mapkey:
                    rm_fourstars = mapkey['fourstars']['count']
                else:
                    rm_fourstars = 0
                if 'threestars' in mapkey:
                    rm_threestars = mapkey['threestars']['count']
                else:
                    rm_threestars = 0
                if 'twostars' in mapkey:
                    rm_twostars = mapkey['twostars']['count']
                else:
                    rm_twostars = 0
                if 'onestars' in mapkey:
                    rm_onestars = mapkey['onestars']['count']
                else:
                    rm_onestars = 0
                cursor = db.cursor()
                cursor.execute("CREATE TABLE IF NOT EXISTS maps(map char(32), runs int(9), fivestars int(9), fourstars int(9), threestars int(9), twostars int(9), onestars int(9));")
                rm_map2 = "'" + rm_map + "'"
                cursor.execute("SELECT map from maps where map = %s;" % rm_map2)
                rm_exists = cursor.fetchall()
                if rm_exists == ():
                    cursor.execute("INSERT INTO maps(map, fivestars, fourstars, threestars, twostars, onestars) VALUES(%s, %d, %d, %d, %d, %d);" % (rm_map2, rm_fivestars, rm_fourstars, rm_threestars, rm_twostars, rm_onestars))
                else:
                    cursor.execute("UPDATE maps SET fivestars = %d where map = %s" % (rm_fivestars, rm_map2))
                    cursor.execute("UPDATE maps SET fourstars = %d where map = %s" % (rm_fourstars, rm_map2))
                    cursor.execute("UPDATE maps SET threestars = %d where map = %s" % (rm_threestars, rm_map2))
                    cursor.execute("UPDATE maps SET twostars = %d where map = %s" % (rm_twostars, rm_map2))
                    cursor.execute("UPDATE maps SET onestars = %d where map = %s" % (rm_onestars, rm_map2))

class DoMapRuns(threading.Thread):
    def run(self):
        if rm_usemysql == 1:
            db = MySQLdb.connect(rm_host, rm_username, rm_password, rm_database)
            rm_map = es.ServerVar("eventscripts_currentmap")
            rm_path = es.getAddonPath('ratemap') + "/data/" + rm_map + '.dat'
            mapkey = keyvalues.KeyValues(name=str(rm_map))
            mapkey.load(rm_path)
            if 'runs' in mapkey:
                rm_runs = mapkey['runs']['count']
                rm_runs += 1
                mapkey['runs']['count'] = rm_runs
                mapkey.save(rm_path)
            else:
                rm_runs = 1
                mapkey['runs'] = keyvalues.KeyValues(name='runs')
                mapkey['runs']['count'] = rm_runs
                mapkey.save(rm_path)
            cursor = db.cursor()
            cursor.execute("CREATE TABLE IF NOT EXISTS maps(map char(32), runs int(9), fivestars int(9), fourstars int(9), threestars int(9), twostars int(9), onestars int(9));")
            rm_map2 = "'" + rm_map + "'"
            cursor.execute("SELECT map from maps where map = %s;" % rm_map2)
            rm_exists = cursor.fetchall()
            if rm_exists == ():
                cursor.execute("INSERT INTO maps(map, runs, fivestars, fourstars, threestars, twostars, onestars) VALUES(%s, %d, %d, %d, %d, %d, %d);" % (rm_map2, rm_runs, rm_fivestars, rm_fourstars, rm_threestars, rm_twostars, rm_onestars))
            else:
                cursor.execute("UPDATE maps SET runs = %d where map = %s" % (rm_runs, rm_map2))

def load():
    es.regsaycmd("!rm", "ratemap/sendpopup", "")
    es.regsaycmd("!rate", "ratemap/sendpopup", "")
    es.regsaycmd("!ratemap", "ratemap/sendpopup", "")
    es.regsaycmd("!rating", "ratemap/viewrating", "")
    es.regsaycmd("!list", "ratemap/listpopup", "")
    es.regsaycmd("!rmhelp", "ratemap/commands", "")
    global rm_map
    rm_map = es.ServerVar("eventscripts_currentmap")
    global rm_path
    rm_path = es.getAddonPath('ratemap') + "/data/" + rm_map + '.dat'
    if not os.path.exists(rm_path):
        mapkey = keyvalues.KeyValues(name=str(rm_map))
        mapkey['fivestars'] = keyvalues.KeyValues(name='fivestars')
        mapkey['fivestars']['count'] = 0
        mapkey['fourstars'] = keyvalues.KeyValues(name='fourstars')
        mapkey['fourstars']['count'] = 0
        mapkey['threestars'] = keyvalues.KeyValues(name='threestars')
        mapkey['threestars']['count'] = 0
        mapkey['twostars'] = keyvalues.KeyValues(name='twostars')
        mapkey['twostars']['count'] = 0
        mapkey['onestars'] = keyvalues.KeyValues(name='onestars')
        mapkey['onestars']['count'] = 0
        mapkey.save(rm_path)
    else:
        mapkey = keyvalues.KeyValues(name=str(rm_map))
        mapkey.load(rm_path)

def unload():
    if popuplib.exists('ratemenu'):
        popuplib.delete('ratemenu')
    if popuplib.exists('rm_popup'):
        popuplib.delete('rm_popup')
    if popuplib.exists('ratemenu'):
        popuplib.delete('ratemenu')
    if popuplib.exists('ratemenu'):
        popuplib.delete('ratemenu')
    es.unregsaycmd("!rm")
    es.unregsaycmd("!rate")
    es.unregsaycmd("!ratemap")
    es.unregsaycmd("!rating")
    es.unregsaycmd("!list")
    es.unregsaycmd("!rmhelp")

def es_map_start(event_var):
    global rm_map
    rm_map = es.ServerVar("eventscripts_currentmap")
    global rm_path
    rm_path = es.getAddonPath('ratemap') + "/data/" + rm_map + '.dat'
    if not os.path.exists(rm_path):
        mapkey = keyvalues.KeyValues(name=str(rm_map))
        mapkey['fivestars'] = keyvalues.KeyValues(name='fivestars')
        mapkey['fivestars']['count'] = 0
        mapkey['fourstars'] = keyvalues.KeyValues(name='fourstars')
        mapkey['fourstars']['count'] = 0
        mapkey['threestars'] = keyvalues.KeyValues(name='threestars')
        mapkey['threestars']['count'] = 0
        mapkey['twostars'] = keyvalues.KeyValues(name='twostars')
        mapkey['twostars']['count'] = 0
        mapkey['onestars'] = keyvalues.KeyValues(name='onestars')
        mapkey['onestars']['count'] = 0
        mapkey.save(rm_path)
    else:
        mapkey = keyvalues.KeyValues(name=str(rm_map))
        mapkey.load(rm_path)
    rm_doruns = DoMapRuns();
    rm_doruns.start()

def round_start(event_var):
    mapkey = keyvalues.KeyValues(name=str(rm_map))
    mapkey.load(rm_path)
    es.tell(event_var["userid"], "#multi", "#green[RateMap]#default is running. Type #lightgreen!rm#default to rate this map.")
    es.msg("#multi", "#green[RateMap]#default Type #lightgreen!rmhelp#default to view all avaliable ratemap commands.")
    getrating(event_var["userid"], rm_map, 2)

def viewrating():
    rm_userid = es.getcmduserid()
    rm_argcount = es.getargc()
    if rm_argcount <= 2:
       if rm_argcount == 1:
           getrating(rm_userid, rm_map, 1)
       if rm_argcount == 2:
           rm_map2 = es.getargv(1)
           getrating(rm_userid, rm_map2, 1)
    else:
       es.tell(int(rm_userid), "#multi", "#green[RateMap]#lightgreen Syntax: !rating [map]")

def sendpopup():
    rm_userid = es.getcmduserid()
    mapkey = keyvalues.KeyValues(name=str(rm_map))
    mapkey.load(rm_path)
    rm_steamid = es.getplayersteamid(rm_userid)
    if rm_steamid in mapkey:
        es.tell(rm_userid, "#multi", "#green[RateMap]#default You have already rated #lightgreen%s#default." % rm_map)
        getrating(rm_userid, rm_map, 1)
    else:
        popuprating(rm_userid)

def popuprating(rm_userid):
    if popuplib.isqueued('ratemenu', rm_userid):
        popuplib.close('ratemenu', rm_userid)
    ratemenu = popuplib.create("ratemenu")
    ratemenu.addline("[RateMap] v.1.2")
    ratemenu.addline("-------------------")
    ratemenu.addline("Map: %s" % rm_map)
    ratemenu.addline("-------------------")
    ratemenu.addline("->1. 5 Stars")
    ratemenu.addline("->2. 4 Stars")
    ratemenu.addline("->3. 3 Stars")
    ratemenu.addline("->4. 2 Stars")
    ratemenu.addline("->5. 1 Star")
    ratemenu.addline("-------------------")
    ratemenu.addline("0. Close")
    ratemenu.addline("-------------------")
    ratemenu.addline("By JoeyT2007")
    ratemenu.select(1, setrating)
    ratemenu.select(2, setrating)
    ratemenu.select(3, setrating)
    ratemenu.select(4, setrating)
    ratemenu.select(5, setrating)
    ratemenu.send(rm_userid)

def setrating(rm_userid, rm_choice, rm_popup):
    mapkey = keyvalues.KeyValues(name=str(rm_map))
    mapkey.load(rm_path)
    if rm_choice == 1:
        rm_stars = "fivestars"
    if rm_choice == 2:
        rm_stars = "fourstars"
    if rm_choice == 3:
        rm_stars = "threestars"
    if rm_choice == 4:
        rm_stars = "twostars"
    if rm_choice == 5:
        rm_stars = "onestars"
    rm_steamid = es.getplayersteamid(rm_userid)
    mapkey[rm_steamid] = keyvalues.KeyValues(name=str(rm_steamid))
    mapkey[rm_steamid]["Rated"] = rm_choice
    rm_count = mapkey[rm_stars]["count"]
    rm_count = int(rm_count)
    rm_count += 1
    mapkey[rm_stars]["count"] = rm_count
    mapkey.save(rm_path)
    rm_sql = DoSql();
    rm_sql.start()
    es.tell(rm_userid, "#multi", "#green[RateMap]#default Thanks for rating #lightgreen%s#default!" % rm_map)
    getrating(rm_userid, rm_map, 1)

def getrating(rm_userid, rm_map2, rm_announce):
    mapkey = keyvalues.KeyValues(name=str(rm_map2))
    rm_path2 = es.getAddonPath('ratemap') + "/data/" + rm_map2 + '.dat'
    if not os.path.exists(rm_path2):
        if rm_announce == 1:
            es.tell(rm_userid, "#multi", "#green[RateMap]#lightgreen " + rm_map2 + "#default hasn't been rated or doesn't exist.")
    else:
        mapkey.load(rm_path2)
        rm_fivestars = mapkey["fivestars"]["count"]
        rm_fourstars = mapkey["fourstars"]["count"]
        rm_threestars = mapkey["threestars"]["count"]
        rm_twostars = mapkey["twostars"]["count"]
        rm_onestars = mapkey["onestars"]["count"]
        rm_total_fivestars = int(rm_fivestars) * 5
        rm_total_fourstars = int(rm_fourstars) * 4
        rm_total_threestars = int(rm_threestars) * 3
        rm_total_twostars = int(rm_twostars) * 2
        rm_total_onestars = int(rm_onestars) * 1
        rm_total_votes = int(rm_fivestars) + int(rm_fourstars) + int(rm_threestars) + int(rm_twostars) + int(rm_onestars)
        rm_total_votes2 = int(rm_total_fivestars) + int(rm_total_fourstars) + int(rm_total_threestars) + int(rm_total_twostars) + int(rm_total_onestars)
        if rm_total_votes != 0:
            rm_map_rating = float(rm_total_votes2) / float(rm_total_votes)
            rm_map_rating = "%.2f"%rm_map_rating
            if rm_announce == 1:
                es.tell(rm_userid, "#multi", "#green[RateMap]#lightgreen " + rm_map2 + "#default: " + rm_map_rating + "/5.00.")
            if rm_announce == 2:
                es.msg("#multi", "#green[RateMap]#lightgreen " + rm_map2 + "#default: " + rm_map_rating + "/5.00.")
        else:
            if rm_announce == 1:
                es.tell(rm_userid, "#multi", "#green[RateMap]#lightgreen " + rm_map2 + "#default hasn't been rated yet.")

def player_team(event_var):
    if rm_onteam == 1:
        mapkey = keyvalues.KeyValues(name=str(rm_map))
        mapkey.load(rm_path)
        rm_steamid = es.getplayersteamid(event_var["userid"])
        if not rm_steamid in mapkey:
            popuprating(event_var["userid"])

def listpopup():
    rm_userid = es.getcmduserid()
    if popuplib.isqueued('ratemenu2', rm_userid):
        popuplib.close('ratemenu2', rm_userid)
    ratemenu2 = popuplib.create('ratemenu2')
    ratemenu2.addline('RateMap v.1.2')
    ratemenu2.addline('-------------------')
    ratemenu2.addline('->1. Name Ascending')
    ratemenu2.addline('->2. Name Descending')
    ratemenu2.addline('->3. Votes Ascending')
    ratemenu2.addline('->4. Votes Descending')
    ratemenu2.addline('->5. Rating Ascending')
    ratemenu2.addline('->6. Rating Descending')
    ratemenu2.addline('-------------------')
    ratemenu2.addline('0. Close')
    ratemenu2.addline('-------------------')
    ratemenu2.menuselect = sort
    ratemenu2.send(rm_userid)

def sort(rm_userid, rm_choice, rm_popupid):
    if rm_choice == 1:
        sortbyname(rm_userid, 1)
    if rm_choice == 2:
        sortbyname(rm_userid, 2)
    if rm_choice == 3:
        sortbyvotes(rm_userid, 1)
    if rm_choice == 4:
        sortbyvotes(rm_userid, 2)
    if rm_choice == 5:
        sortbyrating(rm_userid, 1)
    if rm_choice == 6:
        sortbyrating(rm_userid, 2)

def sortbyname(rm_userid, rm_type):
    rm_namedict = {}
    rm_filepath = es.getAddonPath('ratemap') + "/data/"
    ratemenu3 = popuplib.easymenu('ratemenu3', '_popup_choice', showinfo)
    ratemenu3.settitle("RateMap v.1.2\nMap Rating's")
    for rm_file in os.listdir(rm_filepath):
        rm_file = rm_file.replace(".dat", "")
        rm_namedict[rm_file] = rm_file
    rm_namedict_items = [(v, k) for k, v in rm_namedict.items()]
    rm_namedict_items.sort()
    if rm_type == 2:
        rm_namedict_items.reverse()
    rm_namedict_items = [(k, v) for v, k in rm_namedict_items]
    for rm_key in rm_namedict_items:
        rm_key = str(rm_key)
        rm_name = rm_key.split("', ")[0][2:]
        ratemenu3.addoption(rm_key, rm_name)
    ratemenu3.send(rm_userid)

def sortbyvotes(rm_userid, rm_type):
    rm_filepath = es.getAddonPath('ratemap') + "/data/"
    rm_votedict = {}
    rm_ratingdict = {}
    if popuplib.isqueued('ratemenu4', rm_userid):
        popuplib.close('ratemenu4', rm_userid)
    for rm_file in os.listdir(rm_filepath):
        rm_filepath_full = rm_filepath + rm_file
        rm_maps = keyvalues.KeyValues(name=rm_file)
        rm_maps.load(rm_filepath_full)
        rm_map_fivestars = rm_maps["fivestars"]["count"]
        rm_map_fourstars = rm_maps["fourstars"]["count"]
        rm_map_threestars = rm_maps["threestars"]["count"]
        rm_map_twostars = rm_maps["twostars"]["count"]
        rm_map_onestars = rm_maps["onestars"]["count"]
        rm_map_total_fivestars = rm_map_fivestars * 5
        rm_map_total_fourstars = rm_map_fourstars * 4
        rm_map_total_threestars = rm_map_threestars * 3
        rm_map_total_twostars = rm_map_twostars * 2
        rm_map_total_onestars = rm_map_onestars
        rm_map_votes = rm_map_fivestars + rm_map_twostars + rm_map_threestars + rm_map_fourstars + rm_map_onestars
        rm_map_rating = rm_map_total_fivestars + rm_map_total_twostars + rm_map_total_threestars + rm_map_total_fourstars + rm_map_total_onestars
        rm_votedict[rm_file] = rm_map_votes
        rm_ratingdict[rm_file] = rm_map_rating
    rm_votedict_items = [(v, k) for k, v in rm_votedict.items()]
    rm_votedict_items.sort()
    if rm_type == 1:
        rm_votedict_items.reverse()
    rm_votedict_items = [(k, v) for v, k in rm_votedict_items]
    rm_ratingdict_items = [(v, k) for k, v in rm_ratingdict.items()]
    rm_ratingdict_items.sort()
    if rm_type == 1:
        rm_ratingdict_items.reverse()
    ratemenu4 = popuplib.easymenu('ratemenu4', '_popup_choice', showinfo)
    ratemenu4.settitle("RateMap v.1.2\nMap Rating's")
    rm_ratingdict_items = [(k, v) for v, k in rm_ratingdict_items]
    for rm_key in rm_votedict_items:
        rm_key = str(rm_key)
        rm_name = rm_key.split("', ")[0][2:]
        rm_name = rm_name.replace(".dat", "")
        rm_value = rm_key.split("', ")[1][:4]
        rm_value = rm_value.replace(")", "")
        rm_name = rm_name + " - " + rm_value
        ratemenu4.addoption(rm_key, rm_name)
    ratemenu4.send(rm_userid)

def sortbyrating(rm_userid, rm_type):
    rm_filepath = es.getAddonPath('ratemap') + "/data/"
    rm_votedict = {}
    rm_ratingdict = {}
    rm_totalratingdict = {}
    if popuplib.isqueued('ratemenu5', rm_userid):
        popuplib.close('ratemenu5', rm_userid)
    ratemenu5 = popuplib.easymenu('ratemenu5', '_popup_choice', showinfo)
    ratemenu5.settitle("RateMap v.1.2")
    for rm_file in os.listdir(rm_filepath):
        rm_filepath_full = rm_filepath + rm_file
        rm_maps = keyvalues.KeyValues(name=rm_file)
        rm_maps.load(rm_filepath_full)
        rm_map_fivestars = rm_maps["fivestars"]["count"]
        rm_map_fourstars = rm_maps["fourstars"]["count"]
        rm_map_threestars = rm_maps["threestars"]["count"]
        rm_map_twostars = rm_maps["twostars"]["count"]
        rm_map_onestars = rm_maps["onestars"]["count"]
        rm_map_total_fivestars = rm_map_fivestars * 5
        rm_map_total_fourstars = rm_map_fourstars * 4
        rm_map_total_threestars = rm_map_threestars * 3
        rm_map_total_twostars = rm_map_twostars * 2
        rm_map_total_onestars = rm_map_onestars
        rm_map_votes = rm_map_fivestars + rm_map_twostars + rm_map_threestars + rm_map_fourstars + rm_map_onestars
        rm_map_rating = rm_map_total_fivestars + rm_map_total_twostars + rm_map_total_threestars + rm_map_total_fourstars + rm_map_total_onestars
        rm_votedict[rm_file] = rm_map_votes
        rm_ratingdict[rm_file] = rm_map_rating
        if rm_map_votes != 0:
            rm_map_rating = rm_map_rating + .00
            rm_map_votes = rm_map_votes + .00
            rm_map_total_rating = rm_map_rating / rm_map_votes
        else:
            rm_map_total_rating = 0
        rm_totalratingdict[rm_file] = rm_map_total_rating
    rm_ratingdict_items = [(v, k) for k, v in rm_totalratingdict.items()]
    rm_ratingdict_items.sort()
    if rm_type == 1:
        rm_ratingdict_items.reverse()
    rm_ratingdict_items = [(k, v) for v, k in rm_ratingdict_items]
    for rm_key in rm_ratingdict_items:
        rm_key = str(rm_key)
        rm_key = rm_key.replace(".dat", "")
        rm_name = rm_key.split("', ")[0][2:]
        rm_name_full = rm_name + ".dat"
        rm_map_rating = rm_totalratingdict[rm_name_full]
        rm_name = rm_name + " - " + str("%.2f"%rm_map_rating) + "/5.00"
        ratemenu5.addoption(rm_key, rm_name)
    ratemenu5.send(rm_userid)

def showinfo(rm_userid, rm_choice, rm_popupid):
    if ".dat" in rm_choice:
        rm_choice = rm_choice.replace(".dat", "")
    rm_map_name = rm_choice.split("', ")[0][2:]
    rm_map_path = es.getAddonPath('ratemap') + "/data/" + rm_map_name + ".dat"
    if popuplib.isqueued('ratemenu6', rm_userid):
        popuplib.close('ratemenu6', rm_userid)
    mapkey = keyvalues.KeyValues(name=str(rm_map_name))
    mapkey.load(rm_map_path)
    rm_map_fivestars = mapkey["fivestars"]["count"]
    rm_map_fourstars = mapkey["fourstars"]["count"]
    rm_map_threestars = mapkey["threestars"]["count"]
    rm_map_twostars = mapkey["twostars"]["count"]
    rm_map_onestars = mapkey["onestars"]["count"]
    rm_map_total_fivestars = rm_map_fivestars * 5
    rm_map_total_fourstars = rm_map_fourstars * 4
    rm_map_total_threestars = rm_map_threestars * 3
    rm_map_total_twostars = rm_map_twostars * 2
    rm_map_total_onestars = rm_map_onestars
    rm_map_votes = rm_map_fivestars + rm_map_fourstars + rm_map_threestars + rm_map_twostars + rm_map_onestars
    rm_map_rating = rm_map_total_fivestars + rm_map_total_fourstars + rm_map_total_threestars + rm_map_total_twostars + rm_map_total_onestars
    if rm_map_rating != 0:
        rm_map_rating = rm_map_rating + .00
        rm_map_votes2 = rm_map_votes + .00
        rm_map_rating = rm_map_rating / rm_map_votes2
    rm_steamid = es.getplayersteamid(rm_userid)
    if rm_steamid in mapkey:
        rm_player_rating = mapkey[rm_steamid]["Rated"]
        if rm_player_rating == 1:
            rm_player_rating = "5.00"
        if rm_player_rating == 2:
            rm_player_rating = "4.00"
        if rm_player_rating == 3:
            rm_player_rating = "3.00"
        if rm_player_rating == 4:
            rm_player_rating = "2.00"
        if rm_player_rating == 5:
            rm_player_rating = "1.00"
    if 'runs' in mapkey:
        rm_runs = mapkey['runs']['count']
    else:
        rm_runs = 0
    ratemenu6 = popuplib.create('ratemenu6')
    ratemenu6.addline('RateMap v.1.2')
    ratemenu6.addline('-------------------')
    ratemenu6.addline('Map Name: %s' % rm_map_name)
    ratemenu6.addline('Total Votes: %s' % rm_map_votes)
    ratemenu6.addline('This map has been run: %s times' % rm_runs)
    ratemenu6.addline('Rating: %s' % "%.2f"%rm_map_rating + "/5.00")
    if rm_steamid in mapkey:
        ratemenu6.addline('Your Rating: %s' % rm_player_rating + "/5.00")
    ratemenu6.addline('-------------------')
    ratemenu6.addline('0. Close')
    ratemenu6.addline('-------------------')
    ratemenu6.send(rm_userid)

def commands():
    rm_userid = es.getcmduserid()
    if popuplib.isqueued('ratemenu7', rm_userid):
        popuplib.close('ratemenu7', rm_userid)
    ratemenu7 = popuplib.create('ratemenu7')
    ratemenu7.addline('RateMap v.1.2')
    ratemenu7.addline('-------------------')
    ratemenu7.addline('Help')
    ratemenu7.addline('-------------------')
    ratemenu7.addline('->1. !ratemap')
    ratemenu7.addline('->2. !list')
    ratemenu7.addline('->3. !rating')
    ratemenu7.addline('->4. !rmhelp')
    ratemenu7.addline('-------------------')
    ratemenu7.addline('0. Close')
    ratemenu7.addline('-------------------')
    ratemenu7.menuselect = commanddesc
    ratemenu7.send(rm_userid)

def commanddesc(rm_userid, rm_choice, rm_popupid):
    if popuplib.isqueued('ratemenu8', rm_userid):
        popuplib.close('ratemenu8', rm_userid)
    ratemenu8 = popuplib.create('ratemenu8')
    ratemenu8.addline('RateMap v.1.2')
    ratemenu8.addline('-------------------')
    if rm_choice == 1:
        ratemenu8.addline('!ratemap')
    if rm_choice == 2:
        ratemenu8.addline('!list')
    if rm_choice == 3:
        ratemenu8.addline('!rating')
    if rm_choice == 4:
        ratemenu8.addline('!rmhelp')
    ratemenu8.addline('-------------------')
    if rm_choice == 1:
        ratemenu8.addline('The command used to bring up a popup menu')
        ratemenu8.addline('allowing you to rate the map you are currently')
        ratemenu8.addline('playing on.')
    if rm_choice == 2:
        ratemenu8.addline('This command brings up a menu allowing you')
        ratemenu8.addline('to choose a sort order, picking one will')
        ratemenu8.addline('bring up a popup menu of all maps, choosing')
        ratemenu8.addline('any of these will bring up yet another menu')
        ratemenu8.addline('showing you general statistics for that map.')
    if rm_choice == 3:
        ratemenu8.addline('This command allows you to view the current')
        ratemenu8.addline('maps rating, or any other maps rating by adding')
        ratemenu8.addline('the mapname to the end of the command.')
    if rm_choice == 4:
        ratemenu8.addline('This command just brings up the RateMap help')
        ratemenu8.addline('menu, allowing to view descriptions of each')
        ratemenu8.addline('command.')
    ratemenu8.addline('-------------------')
    ratemenu8.addline('0. Close')
    ratemenu8.addline('-------------------')
    ratemenu8.send(rm_userid)